/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

#pragma once

#include <arrow/flight/sql/client.h>

#include <arrow-flight-sql-glib/client.h>


GAFlightSQLPreparedStatement *
gaflightsql_prepared_statement_new_raw(
  std::shared_ptr<arrow::flight::sql::PreparedStatement> *flight_sql_statement,
  GAFlightSQLClient *client);
std::shared_ptr<arrow::flight::sql::PreparedStatement>
gaflightsql_prepared_statement_get_raw(GAFlightSQLPreparedStatement *statement);

GAFlightSQLClient *
gaflightsql_client_new_raw(
  arrow::flight::sql::FlightSqlClient *flight_sql_client,
  GAFlightClient *client);
arrow::flight::sql::FlightSqlClient *
gaflightsql_client_get_raw(GAFlightSQLClient *client);
